#include"Image.h"

#include<stdio.h>
#include<algorithm>
#include<string>
#include<vector>
#include<math.h>
#include<assert.h>
#include<random>

using namespace std;
using lf = double;

using namespace IMAGE;

struct vec2 {
	lf x, y;
	vec2() {
		x = y = 0;
	}
	vec2(lf x, lf y) :x(x), y(y) {}

	vec2 operator +(const vec2& z) {
		return vec2(x + z.x, y + z.y);
	}
	vec2 operator -(const vec2& z) {
		return vec2(x - z.x, y - z.y);
	}
	vec2 operator *(const lf& z) {
		return vec2(x * z, y * z);
	}
	lf operator *(const vec2& z) {
		return x * z.x + y * z.y;
	}
	void normalize() {
		lf dd = sqrt(x * x + y * y);
		x /= dd;
		y /= dd;
	}
};
using pvi = pair<vec2, int>;
#define MAX_N 300000
int n;
pvi a[MAX_N];
Image img;
Image imagejebi;
Image number[10];
Image imagex;
Image imagey;
int width = 960;
int height = 960;
lf jebiwidth = 120;
lf jebiheight = 120;
lf jebidiff = 150;
lf jebisx = 60;
lf jebisy = 60;
//lf jebidiff = 160;
//lf jebisx = 0;
//lf jebisy = 0;
lf numsize = 60;
lf axissize = 40;
vec2 numoffset(0.0, -10.0);

mt19937 rnd;
int nextint(int s, int t) {
	return (int)(rnd() % (t - s + 1)) + s;
}

void inil()
{
	int i, j, k;
	img.setsize(width, height);

	for (i = 0; i < 10; i++) {
		char xxx[99];
		sprintf(xxx, "numbers/%d.png", i);
		number[i].Load(xxx);
		number[i].set_transparency_color(255, 255, 255, 0);
	}
	imagex.Load("numbers/x.png");
	imagex.set_transparency_color(255, 255, 255, 0);
	imagey.Load("numbers/y.png");
	imagey.set_transparency_color(255, 255, 255, 0);
	imagejebi.Load("jbi.png");
	imagejebi.set_transparency_color(255, 255, 255, 0);
}

void read_data() {
	FILE* fp = fopen("ex1.txt", "rt");
	assert(fp);
	fscanf(fp, "%d", &n);
	for (int i = 0; i < n; i++) {
		fscanf(fp, "%lf %lf %d", &a[i].first.x, &a[i].first.y, &a[i].second);
	}
	fclose(fp);
}
vec2 convertitox(vec2 p) {
	lf x = p.x * jebidiff + jebisx;
	lf y = height - p.y * jebidiff - jebisy;
	return vec2(x, y);
}
void draw_axis()
{
	vec2 zero = convertitox(vec2(0, 0));
	vec2 dx = convertitox(vec2(1, 0)) - zero;
	vec2 dy = convertitox(vec2(0, 1)) - zero;
	//printf("%lf %lf  %lf %lf  %lf %lf\n", zero.x, zero.y, dx.x, dx.y, dy.x, dy.y);
	lf axis_radius = 2.5f;
	lf axis_rr = 0.0f;
	lf axis_gg = 0.0f;
	lf axis_bb = 0.0f;
	// main axis
	img.draw_line(zero.x - dx.x * 0.25, zero.y - dx.y * 0.25, zero.x + dx.x * 5.5, zero.y + dx.y * 5.5, axis_radius, axis_rr, axis_gg, axis_bb);
	img.draw_line(zero.x - dy.x * 0.25, zero.y - dy.y * 0.25, zero.x + dy.x * 5.5, zero.y + dy.y * 5.5, axis_radius, axis_rr, axis_gg, axis_bb);

	// arrow
	img.draw_line(zero.x + dx.x * 5.5, zero.y + dx.y * 5.5, zero.x + dx.x * 5.45 + dy.x * 0.05, zero.y + dx.y * 5.45 + dy.y * 0.05, axis_radius, axis_rr, axis_gg, axis_bb);
	img.draw_line(zero.x + dx.x * 5.5, zero.y + dx.y * 5.5, zero.x + dx.x * 5.45 - dy.x * 0.05, zero.y + dx.y * 5.45 - dy.y * 0.05, axis_radius, axis_rr, axis_gg, axis_bb);

	img.draw_line(zero.x + dy.x * 5.5, zero.y + dy.y * 5.5, zero.x + dy.x * 5.45 + dx.x * 0.05, zero.y + dy.y * 5.45 + dx.y * 0.05, axis_radius, axis_rr, axis_gg, axis_bb);
	img.draw_line(zero.x + dy.x * 5.5, zero.y + dy.y * 5.5, zero.x + dy.x * 5.45 - dx.x * 0.05, zero.y + dy.y * 5.45 - dx.y * 0.05, axis_radius, axis_rr, axis_gg, axis_bb);

	// simbol
	lf xd_size = numsize;
	img.draw_image(zero.x + dx.x * 5.75 - xd_size * 0.5, zero.y + dx.y * 5.75 - xd_size * 0.5, zero.x + dx.x * 5.75 + xd_size * 0.5, zero.y + dx.y * 5.75 + xd_size * 0.5, imagex);
	img.draw_image(zero.x + dy.x * 5.75 - xd_size * 0.5, zero.y + dy.y * 5.75 - xd_size * 0.5, zero.x + dy.x * 5.75 + xd_size * 0.5, zero.y + dy.y * 5.75 + xd_size * 0.5, imagey);
}
void draw_jebi()
{
	int i, j, k;
	for (k = 0; k < 8; k++) {
		vec2 p = convertitox(a[k].first);
		vec2 jb_size = vec2(jebiwidth, jebiheight);

		// draw jebi
		img.draw_image(p.x - jb_size.x * 0.5, p.y - jb_size.y * 0.5, p.x + jb_size.x * 0.5, p.y + jb_size.y * 0.5, imagejebi);

		// draw circle
		lf radius = numsize * 0.5;
		lf alpha = 0.7f;
		img.draw_circle(p.x + numoffset.x, p.y + numoffset.y, radius, 1.0, 1.0, 1.0, alpha);

		// draw number
		img.draw_image(p.x + numoffset.x - numsize * 0.5, p.y + numoffset.y - numsize * 0.5, p.x + numoffset.x + numsize * 0.5, p.y + numoffset.y + numsize * 0.5, number[a[k].second]);
	}
}

void draw_sword()
{
	vec2 s, e;
	lf rr = 0.25;
	lf gg = 0.21;
	lf bb = 0.9;
	lf aa = 0.07;

	lf rpc = 1.6;
	lf gpc = 2.1;
	lf bpc = 0.5;
	int cnt = 20;
	lf radius_max = 35;
	lf sampling_range = 3.5;
	lf morph_radius = jebiheight * 0.5 + max(fabs(numoffset.x), fabs(numoffset.y));

	// Draw sword image

	int rsw = 2048;
	int rsh = 128;
	Image sword1(rsw, rsh);
	Image sword2(rsw, rsh);
	Image sword3(rsw, rsh);
	// fill with sword
	auto swordgen = [rsw, rsh](Image& sword)
	{
		sword.clean(0.0, 0.0, 0.0);
		sword.mAlphaBehavior = AlphaBehaviorType::ONE;
		sword.mSamplingMode = SamplingModeType::SAMPLING_3x3;
		int th = rsh / 4;
		lf alpha = 0.3;
		sword.draw_triangle(
			th * 1.3, th * (2.0 - 0.1),
			rsw - th * 0.1, th * (2.0 + 0.0),
			th * 1.3, th * (2.0 + 0.1),
			1, 1, 1, 0.8);
		for (int i = th; i < rsw - 3 * th; i += th / 4) {
			lf px, py, qx, qy, rx, ry;
			lf aa = alpha * (1.0 - ((lf)i / rsw));
			// draw upsize
			px = i;
			py = nextint(th, 2 * th);
			qx = i + th;
			qy = nextint(th, 2 * th);
			rx = nextint(i, i + th) + th + 2 * th * ((lf)(i) / rsw);
			ry = nextint(2 * th, 4 * th - 2 * th * ((lf)(i) / rsw));
			sword.draw_triangle(px, py, qx, qy, rx, ry, 1, 1, 1, aa);
			// draw downsize
			px = i;
			py = nextint(2 * th, 3 * th);
			qx = i + th;
			qy = nextint(2 * th, 3 * th);
			rx = nextint(i, i + th) + th + 2 * th * ((lf)(i) / rsw);
			ry = nextint(2 * th * ((lf)(i) / rsw), 2 * th);
			sword.draw_triangle(px, py, qx, qy, rx, ry, 1, 1, 1, aa);
		}
	};
	swordgen(sword1);
	swordgen(sword2);
	swordgen(sword3);
	sword3.flip_x();
	sword1.Save("sword.png");

	// define draw function
	auto f = [&rsh, &rsw, &radius_max, &sampling_range, &rpc, &gpc, &bpc](Image& sword, Image& img, vec2 s, vec2 e, lf rr, lf gg, lf bb, lf aa, bool flip = false, lf min_alpha = 0.1, lf max_alpha = 10) {
		lf si = std::min(s.y, e.y) - radius_max;
		lf ei = std::max(s.y, e.y) + radius_max;
		lf sj = std::min(s.x, e.x) - radius_max;
		lf ej = std::max(s.x, e.x) + radius_max;
		for (int i = si; i <= ei; i++) {
			for (int j = sj; j <= ej; j++) {
				lf cy, cx;
				if (flip)
				{
					cy = (j - sj) / (ej - sj) * rsh;
					cx = (i - si) / (ei - si) * rsw;
				}
				else {
					cy = (i - si) / (ei - si) * rsh;
					cx = (j - sj) / (ej - sj) * rsw;
				}

				lf w = 0.01;
				lf res = 0.0;
				for (int ti = cy - sampling_range; ti <= cy + sampling_range; ti++) {
					for (int tj = cx - sampling_range; tj <= cx + sampling_range; tj++) {
						lf dd = (ti - cy) * (ti - cy) + (tj - cx) * (tj - cx);
						lf tw = 1.0 / (sqrt(dd) / sampling_range + 1.0);
						lf tt = 0.0;
						if (ti >= 0 && ti < rsh && tj >= 0 && tj < rsw) {
							int id = (ti * rsw + tj);
							tt += sword.data[id * 4 + 0];
						}
						w += tw;
						res += tt * tw / 255.0;
					}
				}
				res /= w;

				lf rrr = rr * pow(res, rpc);
				lf ggg = gg * pow(res, gpc);
				lf bbb = bb * pow(res, bpc);
				lf aaa = std::max(std::min(max_alpha, aa * res), min_alpha);
				img.set_pixel(i, j, rrr, ggg, bbb, aaa);
			}
		}
	};

	// define morph function
	vector<vector<vector<lf>>> iv = vector<vector<vector<lf>>>(img.h, vector<vector<lf>>(img.w, vector<lf>(4, 0.0)));
	vector<vector<vector<lf>>> rv = vector<vector<vector<lf>>>(img.h, vector<vector<lf>>(img.w, vector<lf>(4, 0.0)));
	vector<vector<vec2>> dv = vector<vector<vec2>>(img.h, vector<vec2>(img.w, vec2(0.0, 0.0)));
	auto g = [&morph_radius, &iv, &dv](Image& img, vec2 s, vec2 e, bool reverse = false) {
		if (reverse) {
			std::swap(s, e);
		}
		lf si = std::min(s.y, e.y) - morph_radius;
		lf ei = std::max(s.y, e.y) + morph_radius;
		lf sj = std::min(s.x, e.x) - morph_radius;
		lf ej = std::max(s.x, e.x) + morph_radius;


		vec2 dir = e - s;
		dir.normalize();
		vec2 tir = vec2(dir.y, -dir.x);

		vec2 sc, ec;
		sc = vec2((s.x - dir.x * morph_radius - sj) / (ej - sj), (s.y - dir.y * morph_radius - si) / (ei - si));
		ec = vec2((e.x + dir.x * morph_radius - sj) / (ej - sj), (e.y + dir.y * morph_radius - si) / (ei - si));

		lf scscale = 1.0 / ((ec * dir) - (sc * dir));
		lf stscale = 1.0 / (1.0);

		int h = img.h;
		int w = img.w;

		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				int id = i * w + j;
				for (int k = 0; k < 4; k++) {
					//rv[i][j][k] += iv[i][j][k];
				}
				if (i >= si && i <= ei && j >= sj && j <= ej)
				{
					//test for random
					//lf ti = i + nextint(-morph_radius, morph_radius) * 0.1;
					//lf tj = j + nextint(-morph_radius, morph_radius) * 0.1;
					// real morph
					lf cy, cx;
					cy = (i - si) / (ei - si);
					cx = (j - sj) / (ej - sj);

					lf scp = dir * sc;
					lf sct = tir * sc;

					lf cp = dir * vec2(cx, cy);
					lf ct = tir * vec2(cx, cy);

					lf w = 1.0 / (0.5 + fabs(ct - sct));

					vec2 cd = vec2((ct - sct) * stscale, (cp - scp) * scscale);
					cd = cd - vec2(0.0, 0.5);
					vec2 dd;
					// cd is [-0.5 ~ 0.5] now. -y --> +y is dir, -x --> +x is tir
					/*
					if (cd.y > 0.0) {
						dd.x = cd.x;
						dd.y = 0.5 - (0.5 - cd.y) * 2.0;
					}
					else {
						dd.x = cd.x * (1.0 + 2.0 * cd.y);
						dd.y = cd.y - fabs(dd.x);
						lf sign = 0.5;
						if (dd.x < 0) sign = -sign;
						dd.x = dd.x * 0.8 + sign * 0.2 * (1.0 - fabs(dd.y) * 2.0);
					}
					dd = dd - cd;
					*/
					lf xsign = 0.5;
					lf ysign = 0.5;
					if (cd.x < 0) xsign = -xsign;
					if (cd.y < 0) ysign = -ysign;
					dd.x = pow(fabs(cd.x) * 2.0, 2.0) * xsign;
					if (cd.y < 0) {
						dd.y = -pow(fabs(cd.y) * 0.2, 0.3) / pow(0.5, 0.3) * 0.75;
					}
					else {
						dd.y = -pow(fabs(0.5 - cd.y), 2.0);
					}
					dd.x = dd.x * 0.7 + xsign * 0.3 * pow(fabs(dd.y), 1.0);
					dd.y = dd.y - 0.5;
					dd.y = -dd.y;

					vec2 td = tir * dd.x + dir * dd.y;
					dv[i][j] = dv[i][j] + td * w;
				}
				else
				{
				}
			}
		}
	};

	// draw x sword
	vec2 xs = convertitox(vec2(0.5, 4)) + numoffset;
	vec2 xe = convertitox(vec2(5.5, 4)) + numoffset;

	//draw y sword
	vec2 ys = convertitox(vec2(1, 0.5)) + numoffset;
	vec2 ye = convertitox(vec2(1, 5.5)) + numoffset;

	//draw y2 sword
	vec2 zs = convertitox(vec2(3, 0.5)) + numoffset;
	vec2 ze = convertitox(vec2(3, 5.5)) + numoffset;
	if (1) {
		// morph basic image follow sword
		for (int i = 0; i < img.h; i++) {
			for (int j = 0; j < img.w; j++) {
				int id = i * img.w + j;
				for (int k = 0; k < 3; k++) {
					iv[i][j][k] = img.data[id * 4 + k] / 255.0;
				}
				iv[i][j][3] = 1.0;
			}
		}

		g(img, xs, xe, true);
		g(img, ys, ye);
		g(img, zs, ze, true);
		for (int i = 0; i < img.h; i++) {
			for (int j = 0; j < img.w; j++) {
				vec2 td = dv[i][j];

				lf dl = sqrt(td * td);
				if (dl < E) {
					for (int k = 0; k < 4; k++) {
						rv[i][j][k] += iv[i][j][k];
					}
					continue;
				}
				if (iv[i][j][0] + iv[i][j][1] + iv[i][j][2] + iv[i][j][3] > 4.0 - E) {
					for (int k = 0; k < 4; k++) {
						rv[i][j][k] += iv[i][j][k];
					}
					//continue;
				}
				if (dl > 0.5) {
					lf scale = 0.5 / dl;
					td = td * scale;
				}
				for (lf m = 0.1; m <= morph_radius; m += 0.1) {
					lf global_scale = 0.1 * pow((lf)m / morph_radius, 3.0);
					lf ti = i + td.y * m;
					lf tj = j + td.x * m;
					// apply color
					{
						int pi = (int)ti;
						int pj = (int)tj;
						if (pi < 0) pi = 0; if (pi >= img.h - 1) pi = img.h - 2;
						if (pj < 0) pj = 0; if (pj >= img.w - 1) pj = img.w - 2;
						int qi = pi + 1;
						int qj = pj + 1;
						lf ppi = qi - ti;
						lf qqi = ti - pi;
						lf ppj = qj - tj;
						lf qqj = tj - pj;
						for (int k = 0; k < 4; k++) {
							rv[pi][pj][k] += iv[i][j][k] * ppi * ppj * global_scale;
							rv[pi][qj][k] += iv[i][j][k] * ppi * qqj * global_scale;
							rv[qi][pj][k] += iv[i][j][k] * qqi * ppj * global_scale;
							rv[qi][qj][k] += iv[i][j][k] * qqi * qqj * global_scale;
						}
					}
				}
			}
		}

		for (int i = 0; i < img.h; i++) {
			for (int j = 0; j < img.w; j++) {
				int id = i * img.w + j;
				lf base = rv[i][j][3];
				if (base < 0.1) {
					for (int k = 0; k < 3; k++) {
						img.data[id * 4 + k] = 255;
					}
				}
				else {
					for (int k = 0; k < 3; k++) {
						lf zz = rv[i][j][k] / base * 255.0;
						if (zz < 0)zz = 0;
						if (zz > 255.0)zz = 255;
						img.data[id * 4 + k] = (uchar)(zz);
					}
				}
			}
		}
	}
	// draw remain jebi  
	for (int k = 8; k < n; k++) {
		vec2 p = convertitox(a[k].first);
		vec2 jb_size = vec2(jebiwidth, jebiheight);

		// draw jebi
		img.draw_image(p.x - jb_size.x * 0.5, p.y - jb_size.y * 0.5, p.x + jb_size.x * 0.5, p.y + jb_size.y * 0.5, imagejebi);

		// draw circle
		lf radius = numsize * 0.5;
		lf alpha = 0.7f;
		img.draw_circle(p.x + numoffset.x, p.y + numoffset.y, radius, 1.0, 1.0, 1.0, alpha);

		// draw number
		img.draw_image(p.x + numoffset.x - numsize * 0.5, p.y + numoffset.y - numsize * 0.5, p.x + numoffset.x + numsize * 0.5, p.y + numoffset.y + numsize * 0.5, number[a[k].second]);
	}
	// draw basic black line
	f(sword1, img, xs, xe, 0, 0, 0, 3, false, 0.0, 0.7);
	f(sword2, img, ys, ye, 0, 0, 0, 3, true, 0.0, 0.7);
	f(sword3, img, zs, ze, 0, 0, 0, 3, true, 0.0, 0.7);

	img.mAlphaBehavior = IMAGE::AlphaBehaviorType::ONE;

	// draw real sword
	f(sword1, img, xs, xe, rr, gg, bb, 5);
	//change color
	std::swap(rr, bb);
	std::swap(rpc, bpc);
	f(sword2, img, ys, ye, rr, gg, bb, 5, true);
	f(sword3, img, zs, ze, rr, gg, bb, 5, true);

	img.mAlphaBehavior = IMAGE::AlphaBehaviorType::ONE_MINUS_ALPHA;
}
int main() {
	int i, j, k;
	inil();
	read_data();

	draw_jebi();
	draw_sword();
	draw_axis();

	img.Save("output.png");
}